//this code detects a keystroke using waitforkeystroke() and then sends the result using USBSend().  It also checks that the key is valid and isn't a repeat.  It also adds shift, ctrl, and fn functionality.

void listen(){
//LISTEN FOR KEYSTROKE AND SEND IT TO PC 
    byte keypressed = 0;
    byte modekeys = 0;
    
    waitcount = 0;
    keypressed = waitForKeystroke();

    if (digitalRead(FNpin) == 0){
          setbit(modekeys,CTRL_F);
    }

    if (digitalRead(SHIFTpin) != polarityshift){
          setbit(modekeys,SHIFT_F);
    }
 if (digitalRead(ALTpin) != polarityalt){
          if (keytocharARRAY[keypressed+100] != INVALID){keypressed += 100;}
          else{setbit(modekeys,ALT_F);}
   }
    if (digitalRead(S2) == 0){  //S2 is used as a secondary alt pin
          if (keytocharARRAY[keypressed+100] != INVALID){keypressed += 100;}
          else{setbit(modekeys,ALT_F);}
    }
    if (digitalRead(CTRLpin) != polarityctrl){
          setbit(modekeys,CTRL_F);
    }
    
  // if this is not the same letter as before (on the +0 or +100 keymap), 
 //or if an appropriate time has been elapsed between two hits of the same key,
 // and the key is valid
 //send the character over USB (in upper or lower case)
       
    if (((keypressed%100 != lastkeypressed)||(waitcount>25)||(repeatcount>10))&&(keypressed != INVALID)){ 
             USBSend((byte)keytocharARRAY[keypressed],modekeys);

    }
    
    if (keypressed != INVALID){
      lastkeypressed = keypressed%100; // lastkeypressed must be a number between 1 and 256
    }      
 }
