//This code defines all variables

#define SERpin  18 // SERpin (serial input)
#define RCLKpin  19 // RCLKpin (shift register clock)
#define SRCLRpin  1 // SRCLRpin (clear) is not used...
#define SPACEBARpin  8
#define TEACHpin 17   //pushbutton that goes into teachmode
#define KEYpin 6
#define SHIFTpin 11
#define CTRLpin 12
#define ALTpin 13
#define S2 16
#define INVALID 0
#define FNpin TEACHpin // Function pin is TeachPin
#define TIMER2FREQ 10//Timer2 interrupts occur every 20ms.


bool TEACH_MODE = false;
bool RECALL_MODE = false;
bool debugLED = false;
bool CTRLflag = false;
int MODE  =  0;

byte keytocharARRAY[200]; //1-99: primary keymap.  100-199: secondary keymap (accessed with Function Key).  
int lastkeypressed = -1;
long lastkeytime = 0;
long keytime;
int waitcount = 0;
long repeatcount = 0;
unsigned int timerLoadValue;

bool polarity7;
bool polarity8;
bool polarity9;
bool polarity10;
bool polarityshift;
bool polarityalt;
bool polarityctrl;

float millisTMR2 = 0;

#define clockTime 10   //each clock pulse must be x microseconds to do anything.
#define keyCheckTime 500  //wait this long (in microseconds) after clocking the shift register before checking if a key has been pressed.

//CUSTOM LETTERS:
#define SHIFT_F 0 // the shift flag is the lsb of the modekeys register
#define CTRL_F 1 //ctrl flag is bit two
#define ALT_F 2 //alt flag is bit three
//and here are the combinations of those flags:
#define LOWER 0  //lower case, no modifiers, mode = b00000000
#define UPPER 1 //upper case, no modifiers, mode = b00000001
#define CTRL_LOWER 2 //lower case, with ctrl, mode = b00000010
#define CTRL_UPPER 3 //upper case, with ctrl, mode = b00000011
#define ALTLOWER 4 //lower case, with alt, mode = b00000100
#define ALTUPPER 5 //upper case, with alt, mode = b00000101
#define ALTCTRLLOWER 6 //lower case, with alt and ctrl, mode = b00000110
#define ALTCTRLUPPER 7 //upper case, with alt and ctrl, mode = b00000111



#define KEY_SEMICOLON 51
#define KEY_PERIOD 55
#define SPACEBARsensor 101
#define SHIFTKEYsensor 254
#define KEY_PERIOD 55
#define KEY_COMMA 54
#define KEY_BACKSPACE 42
#define KEY_DELETE  76
#define KEY_SLASH 56
#define KEY_QUOTES 52
#define KEY_1 30
#define KEY_0 39
#define KEY_8 37
#define KEY_ESC 41
#define KEY_TAB 43
#define KEY_EQ  46 
#define KEY_DASH 45
#define KEY_BACKSLASH 49
#define KEY_LBRACKET 47
#define KEY_RBRACKET 48
#define KEY_TILDE 53

#define KEY_F1 58

#define KEY_RIGHT 79
#define  KEY_LEFT 80
#define KEY_DOWN 81
#define KEY_UP 82
