//This code sends a keystroke then waits a very short amount of time (to avoid glitching and double strokes)

void USBSend(byte usbkeycode){
    mycounter = 0;
    while(mycounter == 0){} //wait till next interrupt completes
    delay1000us();
    UsbKeyboard.sendKeyStroke(usbkeycode);  //note:usbkeycode is not ascii, it is defined by usb standard
    mycounter = 0;
    while(mycounter <5){} //implement 5*16ms = 80ms delay;
    mycounter = 0;
}

//the function can also be called with a mode, such as LOWER, UPPER, or CTRL
void USBSend(byte usbkeycode, int mode){
    mycounter = 0;
    while(mycounter == 0){}  //wait till next interrupt completes  -- thats so a send command doesn't get interrupted.
    delay1000us();
    switch(mode){
    case LOWER: 
      UsbKeyboard.sendKeyStroke(usbkeycode);
      break;
    case UPPER: 
      UsbKeyboard.sendKeyStroke(usbkeycode,MOD_SHIFT_LEFT);
      break;
    case CTRL_LOWER: 
      UsbKeyboard.sendKeyStroke(usbkeycode,MOD_CONTROL_LEFT);
      break;
    case CTRL_UPPER: 
      UsbKeyboard.sendKeyStroke(usbkeycode,MOD_CONTROL_LEFT|MOD_SHIFT_LEFT);
      break;
    case ALTLOWER: 
      UsbKeyboard.sendKeyStroke(usbkeycode,MOD_ALT_LEFT);
      break;
    case ALTUPPER: 
      UsbKeyboard.sendKeyStroke(usbkeycode,MOD_ALT_LEFT|MOD_SHIFT_LEFT);
      break;
    case ALTCTRLLOWER: 
      UsbKeyboard.sendKeyStroke(usbkeycode,MOD_ALT_LEFT|MOD_CONTROL_LEFT);
      break;
    case ALTCTRLUPPER: 
      UsbKeyboard.sendKeyStroke(usbkeycode,MOD_ALT_LEFT|MOD_CONTROL_LEFT|MOD_SHIFT_LEFT);
      break;
    }

    mycounter = 0;
    while(mycounter <5){} //implement 5*16ms = 80ms delay;
    mycounter = 0;
}

